// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from octomap_msgs:msg/Octomap.idl
// generated code does not contain a copyright notice

#ifndef OCTOMAP_MSGS__MSG__DETAIL__OCTOMAP__TRAITS_HPP_
#define OCTOMAP_MSGS__MSG__DETAIL__OCTOMAP__TRAITS_HPP_

#include "octomap_msgs/msg/detail/octomap__struct.hpp"
#include <stdint.h>
#include <rosidl_runtime_cpp/traits.hpp>
#include <sstream>
#include <string>
#include <type_traits>

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"

namespace rosidl_generator_traits
{

inline void to_yaml(
  const octomap_msgs::msg::Octomap & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_yaml(msg.header, out, indentation + 2);
  }

  // member: binary
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "binary: ";
    value_to_yaml(msg.binary, out);
    out << "\n";
  }

  // member: id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "id: ";
    value_to_yaml(msg.id, out);
    out << "\n";
  }

  // member: resolution
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "resolution: ";
    value_to_yaml(msg.resolution, out);
    out << "\n";
  }

  // member: data
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.data.size() == 0) {
      out << "data: []\n";
    } else {
      out << "data:\n";
      for (auto item : msg.data) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        value_to_yaml(item, out);
        out << "\n";
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const octomap_msgs::msg::Octomap & msg)
{
  std::ostringstream out;
  to_yaml(msg, out);
  return out.str();
}

template<>
inline const char * data_type<octomap_msgs::msg::Octomap>()
{
  return "octomap_msgs::msg::Octomap";
}

template<>
inline const char * name<octomap_msgs::msg::Octomap>()
{
  return "octomap_msgs/msg/Octomap";
}

template<>
struct has_fixed_size<octomap_msgs::msg::Octomap>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<octomap_msgs::msg::Octomap>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<octomap_msgs::msg::Octomap>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // OCTOMAP_MSGS__MSG__DETAIL__OCTOMAP__TRAITS_HPP_
